// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "Switch.h"
#include <AFXPRIV.H>

#include "MainFrm.h"
#include "MyFormView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_VIEW_VIEW1, OnViewSwitch)
	ON_UPDATE_COMMAND_UI(ID_VIEW_VIEW1, OnUpdateView1)
	ON_UPDATE_COMMAND_UI(ID_VIEW_VIEW2, OnUpdateView2)
	ON_COMMAND(ID_VIEW_VIEW2, OnViewSwitch)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	m_pView1= NULL;
	m_pView2= NULL;
	m_currentView= 1;
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}
	m_wndToolBar.SetButtonStyle(2, TBBS_CHECKBOX);
	m_wndToolBar.SetButtonStyle(3, TBBS_CHECKBOX);
	m_wndToolBar.SetWindowText("Standard");

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Remove this if you don't want tool tips or a resizeable toolbar
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	m_wndToolBar.SetWindowText("Standard");
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnViewSwitch() 
{
	CView* pViewAdd;
	CView* pViewRemove;
	CDocument* pDoc = GetActiveDocument();
	UINT nCmdID;
	BOOL bCreated= FALSE;

	nCmdID = LOWORD(GetCurrentMessage()->wParam);
   
	if((nCmdID == ID_VIEW_VIEW1) && (m_currentView == 1))
		return;
	if((nCmdID == ID_VIEW_VIEW2) && (m_currentView == 2))
		return;

	if (nCmdID == ID_VIEW_VIEW2)
	{
		if (m_pView2 == NULL)
		{
			m_pView1 = GetActiveView();
			m_pView2 = new CMyFormView;
			m_pView2->Create(NULL, NULL, AFX_WS_DEFAULT_VIEW,
				rectDefault, this, AFX_IDW_PANE_FIRST + 1, NULL);
			bCreated= TRUE;
		}
		pViewAdd = m_pView2;
		pViewRemove = m_pView1;
		m_currentView= 2;
	}
	else
	{
		pViewAdd = m_pView1;
		pViewRemove = m_pView2;
		m_currentView= 1;
	}

	int nSwitchChildID = pViewAdd->GetDlgCtrlID();
	pViewAdd->SetDlgCtrlID(AFX_IDW_PANE_FIRST);
	pViewRemove->SetDlgCtrlID(nSwitchChildID);
// Show the newly active view and hide the inactive view.
	pViewAdd->ShowWindow(SW_SHOW);
	pViewRemove->ShowWindow(SW_HIDE);

// Connect the newly active view to the document, and
// disconnect the inactive view.
	pDoc->AddView(pViewAdd);
	pDoc->RemoveView(pViewRemove);

	if(bCreated)
		m_pView2->SendMessage(WM_INITIALUPDATE, 0, 0);
	SetActiveView(pViewAdd);
	RecalcLayout();
}

void CMainFrame::OnUpdateView1(CCmdUI* pCmdUI) 
{
	if(m_currentView ==1)
		pCmdUI->SetCheck(TRUE);
	else
		pCmdUI->SetCheck(FALSE);

}

void CMainFrame::OnUpdateView2(CCmdUI* pCmdUI) 
{
	if(m_currentView ==2)
		pCmdUI->SetCheck(TRUE);
	else
		pCmdUI->SetCheck(FALSE);
}

